# TODO:
# - finish html5 (BR: vnu.jar)
# - webapp config for -html5? (optional, may be used also locally)
#
# Conditional build:
%bcond_with	gimp	# GIMP plugin
%bcond_with	html5	# HTML5 viewer
%bcond_without	magick	# ImageMagick coder
#
# html5 requires cito that requires mono that is not available yet on x32
%ifarch x32
%undefine	with_html5
%endif

Summary:	RECOIL - Retro Computer Image Library
Summary(pl.UTF-8):	RECOIL (Retro Computer Image Library) - biblioteka do obrazów w formatach komputerów retro
Name:		recoil
Version:	6.4.5
Release:	1
License:	GPL v2+
Group:		Applications/Graphics
Source0:	https://downloads.sourceforge.net/recoil/%{name}-%{version}.tar.gz
# Source0-md5:	51783e0d7aa12594be59d599b65100e9
URL:		http://recoil.sourceforge.net/
%{?with_magick:BuildRequires:	ImageMagick-devel >= 1:6.8}
%{?with_html5:BuildRequires:	asciidoc}
%{?with_html5:BuildRequires:	cito}
%{?with_gimp:BuildRequires:	gimp-devel >= 1:2.0}
BuildRequires:	libpng-devel
BuildRequires:	libxslt-progs
BuildRequires:	zlib-devel
#Obsoletes:	fail < 3
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%if %{with magick}
%define		im_coders_dir	%(pkg-config --variable moduledir MagickCore)/coders
%endif

%description
RECOIL is a viewer of pictures in native formats of vintage computers:
Amiga, Amstrad CPC, Apple II, Atari 8-bit, Atari Portfolio, Atari
ST/TT/Falcon, BBC Micro, Commodore VIC-20, Commodore 16, Commodore 64,
Commodore 128, Electronika BK, FM Towns, Macintosh 128K, MSX,
NEC PC-80/88/98, Oric, Psion Series 3, SAM Coupe, Sharp X68000, Tandy
1000, Timex 2048, TRS-80, TRS-80 Color Computer, ZX81 and ZX Spectrum.

%description -l pl.UTF-8
RECOIL to przeglądarka obrazów w natywnych formatach klasycznych
komputerów: Amiga, Amstrad CPC, Apple II, Atari 8-bitowe, Atari
Portfolio, Atari ST/TT/Falcon, BBC Micro, Commodore VIC-20, Commodore
16, Commodore 64, Commodore 128, Electronika BK, FM Towns, Macintosh
128K, MSX, NEC PC-80/88/98, Oric, Psion Series 3, SAM Coupé, Sharp
X68000, Tandy 1000, Timex 2048, TRS-80, TRS-80 Color Computer, ZX81
oraz ZX Spectrum.

%package gnome
Summary:	RECOIL support for viewing retro computer files in GNOME
Summary(pl.UTF-8):	Wsparcie RECOIL do oglądania plików z komputerów retro w GNOME
Group:		X11/Applications/Graphics
Requires:	%{name} = %{version}-%{release}
Requires:	shared-mime-info
Obsoletes:	fail-gnome < 3

%description gnome
RECOIL support for viewing retro computer files in GNOME.

%description gnome -l pl.UTF-8
Wsparcie RECOIL do oglądania plików z komputerów retro w GNOME.

%package html5
Summary:	HTML5 RECOIL viewer for retro computer files
Summary(pl.UTF-8):	Przeglądarka RECOIL do plików z komputerów retro w HTML5
Group:		Applications/WWW
#Obsoletes:	fail-html5 < 3

%description html5
HTML5 RECOIL viewer for retro computer files.

%description html5 -l pl.UTF-8
Przeglądarka RECOIL do plików z komputerów retro w HTML5.

%package -n ImageMagick-coder-recoil
Summary:	RECOIL coder for ImageMagick
Summary(pl.UTF-8):	Koder RECOIL dla ImageMagicka
Group:		Libraries
%requires_ge_to	ImageMagick ImageMagick-devel
#Obsoletes:	ImageMagick-coder-fail < 3

%description -n ImageMagick-coder-recoil
RECOIL coder for ImageMagick to read retro computer formats.

%description -n ImageMagick-coder-recoil -l pl.UTF-8
Koder RECOIL dla ImageMagicka, czytający formaty komputerów retro.

%package -n gimp-plugin-recoil
Summary:	RECOIL plugin for GIMP
Summary(pl.UTF-8):	Wtyczka RECOIL dla GIMP-a
Group:		X11/Applications/Graphics
Requires:	gimp >= 1:2.0

%description -n gimp-plugin-recoil
RECOIL plugin for GIMP to read retro computer formats.

%description -n gimp-plugin-recoil -l pl.UTF-8
Wtyczka RECOIL dla GIMP-a, czytająca formaty komputerów retro.

%prep
%setup -q

%build
%{__make} all %{?with_gimp:file-recoil} \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} -Wall -I. -DMAGICK7" \
%if %{with magick}
	MAGICK_INCLUDE_PATH=/usr/include/ImageMagick-7/private \
	CAN_INSTALL_MAGICK=1
%endif

%if %{with html5}
%{__make} -C www
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install-recoil2png install-mime install-thumbnailer %{?with_gimp:install-gimp} \
	BUILDING_PACKAGE=1 \
	PREFIX=$RPM_BUILD_ROOT%{_prefix} \
	libdir=$RPM_BUILD_ROOT%{_libdir}

# install-thumbnailer is ugly; for now, install only this one
#install -D recoil-mime.xml $RPM_BUILD_ROOT%{_datadir}/mime/packages/recoil-mime.xml

%if %{with magick}
install -D imagemagick/recoil.so $RPM_BUILD_ROOT%{im_coders_dir}/recoil.so
echo "dlname='recoil.so'" >$RPM_BUILD_ROOT%{im_coders_dir}/recoil.la
%endif

%if %{with html5}
install -d $RPM_BUILD_ROOT%{_datadir}/recoil-html5
cp -p www/*.{js,html} $RPM_BUILD_ROOT%{_datadir}/recoil-html5
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	gnome
%update_mime_database

%postun	gnome
%update_mime_database

%files
%defattr(644,root,root,755)
%doc README
%attr(755,root,root) %{_bindir}/recoil2png
%{_mandir}/man1/recoil2png.1*

%files gnome
%defattr(644,root,root,755)
%{_datadir}/mime/packages/recoil-mime.xml
%{_datadir}/thumbnailers/recoil.thumbnailer

%if %{with html5}
%files html5
%defattr(644,root,root,755)
%{_datadir}/recoil-html5
%endif

%if %{with magick}
%files -n ImageMagick-coder-recoil
%defattr(644,root,root,755)
%attr(755,root,root) %{im_coders_dir}/recoil.so
%{im_coders_dir}/recoil.la
%endif

%if %{with gimp}
%files -n gimp-plugin-recoil
%defattr(644,root,root,755)
%dir %{_libdir}/gimp/2.0/plug-ins/file-recoil
%attr(755,root,root) %{_libdir}/gimp/2.0/plug-ins/file-recoil/file-recoil
%endif
%changelog
* Fri Jan 31 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/recoil.git;a=log;h=master

* Fri Jan 31 2025 Jan Rękorajski <baggins@pld-linux.org> a1c69f6
- up to 6.4.5, disable gimp plugin

* Sun Mar 26 2023 Jakub Bogusz <qboosh@pld-linux.org> 8d92272
- updated to 6.3.3
- added gimp-plugin- package

* Sun Mar 26 2023 Jakub Bogusz <qboosh@pld-linux.org> 797be24
- release 3

* Mon Feb 06 2023 Elan Ruusamäe <glen@delfi.ee> e47a4fe
- ImageMagick 7.1 rebuild

* Fri Apr 15 2022 Jakub Bogusz <qboosh@pld-linux.org> 657b057
- fail successor, updated to 6.1.1

* Fri Apr 15 2022 Jakub Bogusz <qboosh@pld-linux.org> 51d597c
- updated to 2.0.2 (the last version as fail; then continued as recoil)

* Fri Jan 29 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 2317213
- rel 20; simpler/working imagemagick module dir fetching

* Fri Jan 29 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 7b6adcb
- release 19 (by relup.sh)

* Sat Mar 14 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 85e7ec8
- release 18 (by relup.sh)

* Tue Feb 18 2020 Jan Rękorajski <baggins@pld-linux.org> 937d152
- rebuild with ImageMagick 7.0.9.23
- release 17 (by relup.sh)

* Sun Jul 08 2018 Jan Rękorajski <baggins@pld-linux.org> 0a092db
- release 16 (by relup.sh)

* Tue May 22 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 8e251dd
- release 15 (by relup.sh)

* Tue Dec 26 2017 Jan Rękorajski <baggins@pld-linux.org> 684fb9d
- release 14 (by relup.sh)

* Mon Sep 04 2017 Elan Ruusamäe <glen@delfi.ee> 74bd050
- ImageMagick-7.0.7.0-1 rebuild
- release 13 (by relup.sh)

* Thu May 04 2017 Elan Ruusamäe <glen@delfi.ee> 943932f
- ImageMagick-7.0.5-5 rebuild
- release 12 (by relup.sh)

* Tue Dec 27 2016 Jan Rękorajski <baggins@pld-linux.org> 1512e97
- rebuild with ImageMagick 7.0.4.0
- release 11 (by relup.sh)

* Mon Dec 26 2016 Jan Rękorajski <baggins@pld-linux.org> c49f890
- fix building with ImageMagick 7
- rel 10

* Mon Dec 12 2016 Jan Rękorajski <baggins@pld-linux.org> 0014071
- release 9 (by relup.sh)

* Tue Jul 26 2016 Jan Rękorajski <baggins@pld-linux.org> ddc6b82
- release 8 (by relup.sh)

* Mon May 23 2016 Elan Ruusamäe <glen@delfi.ee> 5ef0576
- ImageMagick-6.9.4.1 rebuild
- release 7 (by relup.sh)

